diff --git a/usr.sbin/bthidcontrol/sdp.c b/usr.sbin/bthidcontrol/sdp.c
new file mode 100644
index 0000000000..de4ef42bd7
--- /dev/null
+++ b/usr.sbin/bthidcontrol/sdp.c
@@ -0,0 +1,434 @@
+/*
+ * sdp.c
+ *
+ * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: sdp.c,v 1.3 2004/02/17 22:14:57 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidcontrol/sdp.c 212296 2010-09-07 16:36:03Z emax $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <bus/u4b/usb.h>
+#include <bus/u4b/usbhid.h>
+#include <errno.h>
+#include <sdp.h>
+#include <stdio.h>
+#include <string.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidcontrol.h"
+
+static int32_t hid_sdp_query				(bdaddr_t const *local, struct hid_device *hd, int32_t *error);
+static int32_t hid_sdp_parse_protocol_descriptor_list	(sdp_attr_p a);
+static int32_t hid_sdp_parse_hid_descriptor		(sdp_attr_p a);
+static int32_t hid_sdp_parse_boolean			(sdp_attr_p a);
+
+static uint16_t		service = SDP_SERVICE_CLASS_HUMAN_INTERFACE_DEVICE;
+
+static uint32_t		attrs[] = {
+SDP_ATTR_RANGE(	SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST,
+		SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST),
+SDP_ATTR_RANGE	(SDP_ATTR_ADDITIONAL_PROTOCOL_DESCRIPTOR_LISTS,
+		SDP_ATTR_ADDITIONAL_PROTOCOL_DESCRIPTOR_LISTS),
+SDP_ATTR_RANGE(	0x0205,		/* HIDReconnectInitiate */
+		0x0205),
+SDP_ATTR_RANGE(	0x0206,		/* HIDDescriptorList */
+		0x0206),
+SDP_ATTR_RANGE(	0x0209,		/* HIDBatteryPower */
+		0x0209),
+SDP_ATTR_RANGE(	0x020d,		/* HIDNormallyConnectable */
+		0x020d)
+	};
+#define	nattrs	(sizeof(attrs)/sizeof(attrs[0]))
+
+static sdp_attr_t	values[8];
+#define	nvalues	(sizeof(values)/sizeof(values[0]))
+
+static uint8_t		buffer[nvalues][512];
+
+/*
+ * Query remote device
+ */
+
+#undef	hid_sdp_query_exit
+#define	hid_sdp_query_exit(e) {		\
+	if (error != NULL)		\
+		*error = (e);		\
+	if (ss != NULL) {		\
+		sdp_close(ss);		\
+		ss = NULL;		\
+	}				\
+	return (((e) == 0)? 0 : -1);	\
+}
+
+static int32_t
+hid_sdp_query(bdaddr_t const *local, struct hid_device *hd, int32_t *error)
+{
+	void	*ss = NULL;
+	uint8_t	*hid_descriptor = NULL;
+	int32_t	 i, control_psm = -1, interrupt_psm = -1,
+		 reconnect_initiate = -1,
+		 normally_connectable = 0, battery_power = 0,
+		 hid_descriptor_length = -1;
+
+	if (local == NULL)
+		local = NG_HCI_BDADDR_ANY;
+	if (hd == NULL)
+		hid_sdp_query_exit(EINVAL);
+
+	for (i = 0; i < nvalues; i ++) {
+		values[i].flags = SDP_ATTR_INVALID;
+		values[i].attr = 0;
+		values[i].vlen = sizeof(buffer[i]);
+		values[i].value = buffer[i];
+	}
+
+	if ((ss = sdp_open(local, &hd->bdaddr)) == NULL)
+		hid_sdp_query_exit(ENOMEM);
+	if (sdp_error(ss) != 0)
+		hid_sdp_query_exit(sdp_error(ss));
+	if (sdp_search(ss, 1, &service, nattrs, attrs, nvalues, values) != 0)
+                hid_sdp_query_exit(sdp_error(ss));
+
+        sdp_close(ss);
+        ss = NULL;
+
+	for (i = 0; i < nvalues; i ++) {
+		if (values[i].flags != SDP_ATTR_OK)
+			continue;
+
+		switch (values[i].attr) {
+		case SDP_ATTR_PROTOCOL_DESCRIPTOR_LIST:
+			control_psm = hid_sdp_parse_protocol_descriptor_list(&values[i]);
+			break;
+
+		case SDP_ATTR_ADDITIONAL_PROTOCOL_DESCRIPTOR_LISTS:
+			interrupt_psm = hid_sdp_parse_protocol_descriptor_list(&values[i]);
+			break;
+
+		case 0x0205: /* HIDReconnectInitiate */
+			reconnect_initiate = hid_sdp_parse_boolean(&values[i]);
+			break;
+
+		case 0x0206: /* HIDDescriptorList */
+			if (hid_sdp_parse_hid_descriptor(&values[i]) == 0) {
+				hid_descriptor = values[i].value;
+				hid_descriptor_length = values[i].vlen;
+			}
+			break;
+
+		case 0x0209: /* HIDBatteryPower */
+			battery_power = hid_sdp_parse_boolean(&values[i]);
+			break;
+
+		case 0x020d: /* HIDNormallyConnectable */
+			normally_connectable = hid_sdp_parse_boolean(&values[i]);
+			break;
+		}
+	}
+
+	if (control_psm == -1 || interrupt_psm == -1 ||
+	    reconnect_initiate == -1 ||
+	    hid_descriptor == NULL || hid_descriptor_length == -1)
+		hid_sdp_query_exit(ENOATTR);
+
+	hd->control_psm = control_psm;
+	hd->interrupt_psm = interrupt_psm;
+	hd->reconnect_initiate = reconnect_initiate? 1 : 0;
+	hd->battery_power = battery_power? 1 : 0;
+	hd->normally_connectable = normally_connectable? 1 : 0;
+	hd->desc = hid_use_report_desc(hid_descriptor, hid_descriptor_length);
+	if (hd->desc == NULL)
+		hid_sdp_query_exit(ENOMEM);
+
+	return (0);
+}
+
+/*
+ * seq len				2
+ *	seq len				2
+ *		uuid value		3
+ *		uint16 value		3
+ *		seq len			2
+ *			uuid value	3
+ */
+
+static int32_t
+hid_sdp_parse_protocol_descriptor_list(sdp_attr_p a)
+{
+	uint8_t	*ptr = a->value;
+	uint8_t	*end = a->value + a->vlen;
+	int32_t	 type, len, uuid, psm;
+
+	if (end - ptr < 15)
+		return (-1);
+
+	if (a->attr == SDP_ATTR_ADDITIONAL_PROTOCOL_DESCRIPTOR_LISTS) {
+		SDP_GET8(type, ptr);
+		switch (type) {
+		case SDP_DATA_SEQ8:
+			SDP_GET8(len, ptr);
+			break;
+
+		case SDP_DATA_SEQ16:
+			SDP_GET16(len, ptr);
+			break;
+
+		case SDP_DATA_SEQ32:
+			SDP_GET32(len, ptr);
+			break;
+
+		default:
+			return (-1);
+		}
+		if (ptr + len > end)
+			return (-1);
+	}
+
+	SDP_GET8(type, ptr);
+	switch (type) {
+	case SDP_DATA_SEQ8:
+		SDP_GET8(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ16:
+		SDP_GET16(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ32:
+		SDP_GET32(len, ptr);
+		break;
+
+	default:
+		return (-1);
+	}
+	if (ptr + len > end)
+		return (-1);
+
+	/* Protocol */
+	SDP_GET8(type, ptr);
+	switch (type) {
+	case SDP_DATA_SEQ8:
+		SDP_GET8(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ16:
+		SDP_GET16(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ32:
+		SDP_GET32(len, ptr);
+		break;
+
+	default:
+		return (-1);
+	}
+	if (ptr + len > end)
+		return (-1);
+
+	/* UUID */
+	if (ptr + 3 > end)
+		return (-1);
+	SDP_GET8(type, ptr);
+	switch (type) {
+	case SDP_DATA_UUID16:
+		SDP_GET16(uuid, ptr);
+		if (uuid != SDP_UUID_PROTOCOL_L2CAP)
+			return (-1);
+		break;
+
+	case SDP_DATA_UUID32:  /* XXX FIXME can we have 32-bit UUID */
+	case SDP_DATA_UUID128: /* XXX FIXME can we have 128-bit UUID */
+	default:
+		return (-1);
+	}
+
+	/* PSM */
+	if (ptr + 3 > end)
+		return (-1);
+	SDP_GET8(type, ptr);
+	if (type != SDP_DATA_UINT16)
+		return (-1);
+	SDP_GET16(psm, ptr);
+
+	return (psm);
+}
+
+/*
+ * seq len			2
+ *	seq len			2
+ *		uint8 value8	2
+ * 		str value	3
+ */
+
+static int32_t
+hid_sdp_parse_hid_descriptor(sdp_attr_p a)
+{
+	uint8_t	*ptr = a->value;
+	uint8_t	*end = a->value + a->vlen;
+	int32_t	 type, len, descriptor_type;
+
+	if (end - ptr < 9)
+		return (-1);
+
+	SDP_GET8(type, ptr);
+	switch (type) {
+	case SDP_DATA_SEQ8:
+		SDP_GET8(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ16:
+		SDP_GET16(len, ptr);
+		break;
+
+	case SDP_DATA_SEQ32:
+		SDP_GET32(len, ptr);
+		break;
+
+	default:
+		return (-1);
+	}
+	if (ptr + len > end)
+		return (-1);
+
+	while (ptr < end) {
+		/* Descriptor */
+		SDP_GET8(type, ptr);
+		switch (type) {
+		case SDP_DATA_SEQ8:
+			if (ptr + 1 > end)
+				return (-1);
+			SDP_GET8(len, ptr);
+			break;
+
+		case SDP_DATA_SEQ16:
+			if (ptr + 2 > end)
+				return (-1);
+			SDP_GET16(len, ptr);
+			break;
+
+		case SDP_DATA_SEQ32:
+			if (ptr + 4 > end)
+				return (-1);
+			SDP_GET32(len, ptr);
+			break;
+
+		default:
+			return (-1);
+		}
+
+		/* Descripor type */
+		if (ptr + 1 > end)
+			return (-1);
+		SDP_GET8(type, ptr);
+		if (type != SDP_DATA_UINT8 || ptr + 1 > end)
+			return (-1);
+		SDP_GET8(descriptor_type, ptr);
+
+		/* Descriptor value */
+		if (ptr + 1 > end)
+			return (-1);
+		SDP_GET8(type, ptr);
+		switch (type) {
+		case SDP_DATA_STR8:
+			if (ptr + 1 > end)
+				return (-1);
+			SDP_GET8(len, ptr);
+			break;
+
+		case SDP_DATA_STR16:
+			if (ptr + 2 > end)
+				return (-1);
+			SDP_GET16(len, ptr);
+			break;
+
+		case SDP_DATA_STR32:
+			if (ptr + 4 > end)
+				return (-1);
+			SDP_GET32(len, ptr);
+			break;
+
+		default:
+			return (-1);
+		}
+		if (ptr + len > end)
+			return (-1);
+
+		if (descriptor_type == UDESC_REPORT && len > 0) {
+			a->value = ptr;
+			a->vlen = len;
+
+			return (0);
+		}
+
+		ptr += len;
+	}
+
+	return (-1);
+}
+
+/* bool8 int8 */
+static int32_t
+hid_sdp_parse_boolean(sdp_attr_p a)
+{
+	if (a->vlen != 2 || a->value[0] != SDP_DATA_BOOL)
+		return (-1);
+
+	return (a->value[1]);
+}
+
+/* Perform SDP query */
+static int32_t
+hid_query(bdaddr_t *bdaddr, int argc, char **argv)
+{
+	struct hid_device	hd;
+	int			e;
+
+	memcpy(&hd.bdaddr, bdaddr, sizeof(hd.bdaddr));
+	if (hid_sdp_query(NULL, &hd, &e) < 0) {
+		fprintf(stderr, "Could not perform SDP query on the " \
+			"device %s. %s (%d)\n", bt_ntoa(bdaddr, NULL),
+			strerror(e), e);
+		return (FAILED);
+	}
+
+	print_hid_device(&hd, stdout);
+
+	return (OK);
+}
+
+struct bthid_command	sdp_commands[] =
+{
+{
+"Query",
+"Perform SDP query to the specified device and print HID configuration entry\n"\
+"for the device. The configuration entry should be appended to the Bluetooth\n"\
+"HID daemon configuration file and the daemon should be restarted.\n",
+hid_query
+},
+{ NULL, NULL, NULL }
+};
+
diff --git a/usr.sbin/bthidd/Makefile b/usr.sbin/bthidd/Makefile
new file mode 100644
index 0000000000..5794985fb4
--- /dev/null
+++ b/usr.sbin/bthidd/Makefile
@@ -0,0 +1,18 @@
+# $Id: Makefile,v 1.6 2006/09/07 21:36:55 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/bthidd/Makefile 249657 2013-04-19 19:45:00Z ed $
+
+PROG=		bthidd
+MAN=		bthidd.8
+#		bthidd.conf.5
+SRCS=		bthidd.c client.c hid.c kbd.c lexer.l parser.y server.c \
+		session.c
+
+CFLAGS+=	-I${.CURDIR}
+DEBUG_FLAGS=	-g
+
+DPADD=          ${LIBBLUETOOTH} ${LIBUSBHID}
+LDADD=		-lbluetooth -lusbhid
+
+NO_WMISSING_VARIABLE_DECLARATIONS=
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/bthidd/bthid_config.h b/usr.sbin/bthidd/bthid_config.h
new file mode 100644
index 0000000000..81481b29b3
--- /dev/null
+++ b/usr.sbin/bthidd/bthid_config.h
@@ -0,0 +1,70 @@
+/*
+ * bthid_config.h
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthid_config.h,v 1.4 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/bthid_config.h 162128 2006-09-07 21:47:49Z emax $
+ */
+
+#ifndef _BTHID_CONFIG_H_
+#define _BTHID_CONFIG_H_ 1
+
+#define BTHIDD_CONFFILE		"/etc/bluetooth/bthidd.conf"
+#define BTHIDD_HIDSFILE		"/var/db/bthidd.hids"
+
+struct hid_device
+{
+	bdaddr_t		bdaddr;		/* HID device BDADDR */
+	uint16_t		control_psm;	/* control PSM */
+	uint16_t		interrupt_psm;	/* interrupt PSM */
+	unsigned		new_device           : 1;
+	unsigned		reconnect_initiate   : 1;
+	unsigned		battery_power        : 1;
+	unsigned		normally_connectable : 1;
+	unsigned		keyboard             : 1;
+	unsigned		reserved             : 11;
+	report_desc_t		desc;		/* HID report descriptor */
+	LIST_ENTRY(hid_device)	next;		/* link to the next */
+};
+typedef struct hid_device	hid_device_t;
+typedef struct hid_device *	hid_device_p;
+
+extern char const	*config_file;
+extern char const	*hids_file;
+
+int32_t		read_config_file	(void);
+void		clean_config		(void);
+hid_device_p	get_hid_device		(bdaddr_p bdaddr);
+hid_device_p	get_next_hid_device	(hid_device_p d);
+void		print_hid_device	(hid_device_p hid_device, FILE *f);
+
+int32_t		read_hids_file		(void);
+int32_t		write_hids_file		(void);
+
+#endif /* ndef _BTHID_CONFIG_H_ */
+
diff --git a/usr.sbin/bthidd/bthidd.c b/usr.sbin/bthidd/bthidd.c
new file mode 100644
index 0000000000..245bd7da65
--- /dev/null
+++ b/usr.sbin/bthidd/bthidd.c
@@ -0,0 +1,266 @@
+/*
+ * bthidd.c
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthidd.c,v 1.8 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/bthidd.c 162128 2006-09-07 21:47:49Z emax $
+ */
+
+#include <sys/time.h>
+#include <sys/queue.h>
+#include <assert.h>
+#include <bluetooth.h>
+#include <err.h>
+#include <errno.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidd.h"
+
+static int32_t	write_pid_file	(char const *file);
+static int32_t	remove_pid_file	(char const *file);
+static int32_t	elapsed		(int32_t tval);
+static void	sighandler	(int32_t s);
+static void	usage		(void);
+
+/*
+ * bthidd
+ */
+
+static int32_t	done = 0; /* are we done? */
+
+int32_t
+main(int32_t argc, char *argv[])
+{
+	struct bthid_server	 srv;
+	struct sigaction	 sa;
+	char const		*pid_file = BTHIDD_PIDFILE;
+	char			*ep;
+	int32_t			 opt, detach, tval;
+
+	memset(&srv, 0, sizeof(srv));
+	memset(&srv.bdaddr, 0, sizeof(srv.bdaddr));
+	detach = 1;
+	tval = 10; /* sec */
+
+	while ((opt = getopt(argc, argv, "a:c:dH:hp:t:")) != -1) {
+		switch (opt) {
+		case 'a': /* BDADDR */
+			if (!bt_aton(optarg, &srv.bdaddr)) {
+				struct hostent  *he;
+
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+
+				memcpy(&srv.bdaddr, he->h_addr, sizeof(srv.bdaddr));
+			}
+			break;
+			
+		case 'c': /* config file */
+			config_file = optarg;
+			break;
+
+		case 'd': /* do not detach */
+			detach = 0;
+			break;
+
+		case 'H': /* hids file */
+			hids_file = optarg;
+			break;
+
+		case 'p': /* pid file */
+			pid_file = optarg;
+			break;
+
+		case 't': /* rescan interval */
+			tval = strtol(optarg, (char **) &ep, 10);
+			if (*ep != '\0' || tval <= 0)
+				usage();
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	openlog(BTHIDD_IDENT, LOG_PID|LOG_PERROR|LOG_NDELAY, LOG_USER);
+
+	/* Become daemon if required */
+	if (detach && daemon(0, 0) < 0) {
+		syslog(LOG_CRIT, "Could not become daemon. %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	/* Install signal handler */
+	memset(&sa, 0, sizeof(sa));
+	sa.sa_handler = sighandler;
+
+	if (sigaction(SIGTERM, &sa, NULL) < 0 ||
+	    sigaction(SIGHUP, &sa, NULL) < 0 ||
+	    sigaction(SIGINT, &sa, NULL) < 0) {
+		syslog(LOG_CRIT, "Could not install signal handlers. %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	sa.sa_handler = SIG_IGN;
+	if (sigaction(SIGPIPE, &sa, NULL) < 0) {
+		syslog(LOG_CRIT, "Could not install signal handlers. %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	sa.sa_handler = SIG_IGN;
+	sa.sa_flags = SA_NOCLDSTOP|SA_NOCLDWAIT;
+	if (sigaction(SIGCHLD, &sa, NULL) < 0) {
+		syslog(LOG_CRIT, "Could not install signal handlers. %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	if (read_config_file() < 0 || read_hids_file() < 0 ||
+	    server_init(&srv) < 0 || write_pid_file(pid_file) < 0)
+		exit(1);
+
+	for (done = 0; !done; ) {
+		if (elapsed(tval))
+			client_rescan(&srv);
+
+		if (server_do(&srv) < 0)
+			break;
+	}
+
+	server_shutdown(&srv);
+	remove_pid_file(pid_file);
+	clean_config();
+	closelog();
+
+	return (0);
+}
+
+/*
+ * Write pid file
+ */
+
+static int32_t
+write_pid_file(char const *file)
+{
+	FILE	*pid;
+
+	assert(file != NULL);
+
+	if ((pid = fopen(file, "w")) == NULL) {
+		syslog(LOG_ERR, "Could not open file %s. %s (%d)",
+			file, strerror(errno), errno);
+		return (-1);
+	}
+
+	fprintf(pid, "%d", getpid());
+	fclose(pid);
+
+	return (0);
+}
+
+/*
+ * Remote pid file
+ */
+
+static int32_t
+remove_pid_file(char const *file)
+{
+	assert(file != NULL);
+
+	if (unlink(file) < 0) {
+		syslog(LOG_ERR, "Could not unlink file %s. %s (%d)",
+			file, strerror(errno), errno);
+		return (-1);
+	}
+
+	return (0);
+}
+
+/*
+ * Returns true if desired time interval has elapsed
+ */
+
+static int32_t
+elapsed(int32_t tval)
+{
+	static struct timeval	last = { 0, 0 };
+	struct timeval		now;
+
+	gettimeofday(&now, NULL);
+
+	if (now.tv_sec - last.tv_sec >= tval) {
+		last = now;
+		return (1);
+	}
+
+	return (0);
+}
+
+/*
+ * Signal handler
+ */
+
+static void
+sighandler(int32_t s)
+{
+	syslog(LOG_NOTICE, "Got signal %d, total number of signals %d",
+		s, ++ done);
+}
+
+/*
+ * Display usage and exit
+ */
+
+static void
+usage(void)
+{
+	fprintf(stderr,
+"Usage: %s [options]\n" \
+"Where options are:\n" \
+"	-a address	specify address to listen on (default ANY)\n" \
+"	-c file		specify config file name\n" \
+"	-d		run in foreground\n" \
+"	-H file		specify known HIDs file name\n" \
+"	-h		display this message\n" \
+"	-p file		specify PID file name\n" \
+"	-t tval		specify client rescan interval (sec)\n" \
+"", BTHIDD_IDENT);
+	exit(255);
+}
+
diff --git a/usr.sbin/bthidd/bthidd.conf.sample b/usr.sbin/bthidd/bthidd.conf.sample
new file mode 100644
index 0000000000..a1afed2ce5
--- /dev/null
+++ b/usr.sbin/bthidd/bthidd.conf.sample
@@ -0,0 +1,72 @@
+# $FreeBSD: head/usr.sbin/bluetooth/bthidd/bthidd.conf.sample 162128 2006-09-07 21:47:49Z emax $
+
+device {
+	bdaddr			00:50:f2:e5:68:84;
+	control_psm		0x11;
+	interrupt_psm		0x13;
+	reconnect_initiate	true;
+	normally_connectable	false;
+	hid_descriptor		{
+		0x05 0x01 0x09 0x02 0xa1 0x01 0x85 0x02 
+		0x09 0x01 0xa1 0x00 0x05 0x09 0x19 0x01 
+		0x29 0x05 0x15 0x00 0x25 0x01 0x75 0x01 
+		0x95 0x05 0x81 0x02 0x75 0x03 0x95 0x01 
+		0x81 0x01 0x05 0x01 0x09 0x30 0x09 0x31 
+		0x09 0x38 0x15 0x81 0x25 0x7f 0x75 0x08 
+		0x95 0x03 0x81 0x06 0xc0 0xc0 0x05 0x0c 
+		0x09 0x01 0xa1 0x01 0x85 0x03 0x05 0x01 
+		0x09 0x02 0xa1 0x02 0x06 0x00 0xff 0x15 
+		0x00 0x25 0x03 0x95 0x01 0x75 0x02 0x0a 
+		0x01 0xfe 0x81 0x02 0x75 0x06 0x81 0x01 
+		0xc0 0xc0 
+	};
+}
+
+device {
+	bdaddr			00:50:f2:e3:fb:e1;
+	control_psm		0x11;
+	interrupt_psm		0x13;
+	reconnect_initiate	true;
+	normally_connectable	false;
+	hid_descriptor		{
+		0x05 0x01 0x09 0x06 0xa1 0x01 0x85 0x01 
+		0x05 0x08 0x19 0x01 0x29 0x03 0x15 0x00 
+		0x25 0x01 0x75 0x01 0x95 0x03 0x91 0x02 
+		0x09 0x4b 0x95 0x01 0x91 0x02 0x95 0x04 
+		0x91 0x01 0x05 0x07 0x19 0xe0 0x29 0xe7 
+		0x95 0x08 0x81 0x02 0x75 0x08 0x95 0x01 
+		0x81 0x01 0x19 0x00 0x29 0x91 0x26 0xff 
+		0x00 0x95 0x06 0x81 0x00 0xc0 0x05 0x0c 
+		0x09 0x01 0xa1 0x01 0x85 0x02 0x05 0x0c 
+		0x15 0x00 0x25 0x01 0x75 0x01 0x95 0x1c 
+		0x09 0xe2 0x09 0xb7 0x09 0xcd 0x09 0xea 
+		0x09 0xe9 0x09 0xb6 0x09 0xb5 0x0a 0x83 
+		0x01 0x0a 0x1a 0x02 0x0a 0x79 0x02 0x0a 
+		0xab 0x01 0x0a 0x08 0x02 0x0a 0x02 0x02 
+		0x0a 0x03 0x02 0x0a 0x07 0x02 0x0a 0x01 
+		0x02 0x0a 0x92 0x01 0x0a 0x9c 0x01 0x09 
+		0x95 0x0a 0x23 0x02 0x0a 0x89 0x02 0x0a 
+		0x8b 0x02 0x0a 0x8c 0x02 0x0a 0x8a 0x01 
+		0x0a 0x99 0x01 0x0a 0xa7 0x01 0x0a 0xb6 
+		0x01 0x0a 0xb7 0x01 0x81 0x02 0x75 0x01 
+		0x95 0x04 0x81 0x01 0x06 0x00 0xff 0x0a 
+		0x02 0xff 0x26 0xff 0x00 0x95 0x01 0x75 
+		0x08 0x81 0x02 0xc0 0x05 0x01 0x09 0x80 
+		0xa1 0x01 0x85 0x03 0x19 0x81 0x29 0x83 
+		0x25 0x01 0x95 0x03 0x75 0x01 0x81 0x02 
+		0x95 0x05 0x81 0x01 0xc0 0x05 0x0c 0x09 
+		0x01 0xa1 0x01 0x85 0x04 0x05 0x01 0x09 
+		0x06 0xa1 0x02 0x06 0x00 0xff 0x15 0x00 
+		0x25 0x03 0x95 0x01 0x75 0x02 0x0a 0x01 
+		0xfe 0x81 0x02 0x75 0x06 0x81 0x01 0xc0 
+		0xc0 0x05 0x0c 0x09 0x01 0xa1 0x01 0x85 
+		0x05 0x05 0x01 0x09 0x06 0xa1 0x02 0x06 
+		0x00 0xff 0x25 0x01 0x75 0x01 0x95 0x02 
+		0x0a 0x03 0xfe 0x0a 0x04 0xfe 0x81 0x02 
+		0x95 0x06 0x81 0x01 0xc0 0xc0 0x05 0x0c 
+		0x09 0x01 0xa1 0x01 0x85 0xff 0x05 0x06 
+		0x95 0x01 0x75 0x02 0x19 0x24 0x29 0x26 
+		0x81 0x02 0x75 0x06 0x81 0x01 0xc0 
+	};
+}
+
diff --git a/usr.sbin/bthidd/bthidd.h b/usr.sbin/bthidd/bthidd.h
new file mode 100644
index 0000000000..d6e412358a
--- /dev/null
+++ b/usr.sbin/bthidd/bthidd.h
@@ -0,0 +1,93 @@
+/*
+ * bthidd.h
+ */
+
+/*-
+ * Copyright (c) 2006 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthidd.h,v 1.7 2006/09/07 21:06:53 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidd/bthidd.h 162128 2006-09-07 21:47:49Z emax $
+ */
+
+#ifndef _BTHIDD_H_
+#define _BTHIDD_H_ 1
+
+#define BTHIDD_IDENT	"bthidd"
+#define BTHIDD_PIDFILE	"/var/run/" BTHIDD_IDENT ".pid"
+
+struct bthid_session;
+
+struct bthid_server
+{
+	bdaddr_t			 bdaddr; /* local bdaddr */
+	int32_t				 cons;	 /* /dev/consolectl */
+	int32_t				 ctrl;   /* control channel (listen) */
+	int32_t				 intr;   /* intr. channel (listen) */
+	int32_t				 maxfd;	 /* max fd in sets */
+	fd_set				 rfdset; /* read descriptor set */
+	fd_set				 wfdset; /* write descriptor set */
+	LIST_HEAD(, bthid_session)	 sessions;
+};
+
+typedef struct bthid_server	bthid_server_t;
+typedef struct bthid_server *	bthid_server_p;
+
+struct bthid_session
+{
+	bthid_server_p			 srv;	/* pointer back to server */
+	int32_t				 ctrl;	/* control channel */
+	int32_t				 intr;	/* interrupt channel */
+	int32_t				 vkbd;	/* virual keyboard */
+	bdaddr_t			 bdaddr;/* remote bdaddr */
+	uint16_t			 state;	/* session state */
+#define CLOSED	0
+#define	W4CTRL	1
+#define	W4INTR	2
+#define	OPEN	3
+	bitstr_t			*keys1;	/* keys map (new) */
+	bitstr_t			*keys2;	/* keys map (old) */
+	LIST_ENTRY(bthid_session)	 next;	/* link to next */
+};
+
+typedef struct bthid_session	bthid_session_t;
+typedef struct bthid_session *	bthid_session_p;
+
+int32_t		server_init      (bthid_server_p srv);
+void		server_shutdown  (bthid_server_p srv);
+int32_t		server_do        (bthid_server_p srv);
+
+int32_t		client_rescan    (bthid_server_p srv);
+int32_t		client_connect   (bthid_server_p srv, int fd);
+
+bthid_session_p	session_open     (bthid_server_p srv, hid_device_p const d);
+bthid_session_p	session_by_bdaddr(bthid_server_p srv, bdaddr_p bdaddr);
+bthid_session_p	session_by_fd    (bthid_server_p srv, int32_t fd);
+void		session_close    (bthid_session_p s);
+
+int32_t		hid_control      (bthid_session_p s, uint8_t *data, int32_t len);
+int32_t		hid_interrupt    (bthid_session_p s, uint8_t *data, int32_t len);
+
+#endif /* ndef _BTHIDD_H_ */
+
